"""
Django settings for textassembler project.

Generated by 'django-admin startproject' using Django 2.2.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os
from configparser import ConfigParser, NoOptionError
import logging
import datetime
import sys

def load_configs(path_to_configs):
    """Load configs from default location."""
    configs = ConfigParser()
    # Load configs preserving case
    configs.optionxform = str
    # Individual configs accessed via configs object.
    with open(path_to_configs) as conf_file:
        configs.read_file(conf_file)
    return configs

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Not auto-appending slash to url as that results in loss of data in redirect to url with slash.
APPEND_SLASH = False

# Secure settings (including passwords) stored in additional settings file, and loaded below.
if os.path.exists(os.path.join(BASE_DIR, "textassembler.cfg")):
    SECURE_SETTINGS = os.path.join(BASE_DIR, "textassembler.cfg")
else:
    SECURE_SETTINGS = os.path.join(BASE_DIR, "textassembler.cfg.example")

# Load configs from location in SECURE_SETTINGS
CONFIGS = load_configs(SECURE_SETTINGS)

# App Name
APP_NAME = CONFIGS.get("general", "APP_NAME")

# Storage location where search results will be saved
STORAGE_LOCATION = CONFIGS.get("general", "STORAGE_LOCATION")

# Max number of results a non-admin user is allowed to queue a search for
MAX_RESULTS_ALLOWED = int(CONFIGS.get("general", "MAX_RESULTS_ALLOWED"))

# Max number of concurrent searches a non-admin is allowed to queue at once
MAX_CONCURRENT_SEARCHES = int(CONFIGS.get("general", "MAX_CONCURRENT_SEARCHES"))

# LexisNexis Configs
LN_TOKEN_URL = CONFIGS.get("lexisnexis", "TOKEN_URL")
LN_CLIENT_ID = CONFIGS.get("lexisnexis", "CLIENT_ID")
LN_CLIENT_SECRET = CONFIGS.get("lexisnexis", "CLIENT_SECRET")
LN_SCOPE = CONFIGS.get("lexisnexis", "SCOPE")
LN_API_URL = CONFIGS.get("lexisnexis", "API_URL")
LN_DOWNLOAD_PER_CALL = int(CONFIGS.get("lexisnexis", "DOWNLOAD_PER_CALL"))
LN_MAX_RETRY = int(CONFIGS.get("lexisnexis", "MAX_RETRY"))
LN_TIMEOUT = int(CONFIGS.get("lexisnexis", "TIMEOUT_SECONDS"))
PREVIEW_FORMAT = CONFIGS.get("lexisnexis", "PREVIEW_FORMAT")
NUM_MONTHS_KEEP_SEARCHES = int(CONFIGS.get("lexisnexis", "NUM_MONTHS_KEEP_SEARCHES"))

# Processor configs
DB_WAIT_TIME = int(CONFIGS.get("processor", "DB_WAIT_TIME"))
STORAGE_WAIT_TIME = int(CONFIGS.get("processor", "STORAGE_WAIT_TIME"))
LN_WAIT_TIME = int(CONFIGS.get("processor", "LN_WAIT_TIME"))
NUM_RETRIES = int(CONFIGS.get("processor", "NUM_RETRIES"))
MAX_SAVER_QUEUE_SIZE = int(CONFIGS.get("processor", "MAX_SAVER_QUEUE_SIZE"))
MAX_FILES_PER_DIR = int(CONFIGS.get("processor", "MAX_FILES_PER_DIR"))
MAX_API_FAILURES_PER_HOUR = int(CONFIGS.get("processor", "MAX_API_FAILURES_PER_HOUR"))

# API Limits
try:
    SEARCHES_PER_MINUTE = int(CONFIGS.get("api.limits", "SEARCHES_PER_MINUTE"))
except NoOptionError:
    SEARCHES_PER_MINUTE = None
try:
    SEARCHES_PER_HOUR = int(CONFIGS.get("api.limits", "SEARCHES_PER_HOUR"))
except NoOptionError:
    SEARCHES_PER_HOUR = None
try:
    SEARCHES_PER_DAY = int(CONFIGS.get("api.limits", "SEARCHES_PER_DAY"))
except NoOptionError:
    SEARCHES_PER_DAY = None
try:
    DOWNLOADS_PER_MINUTE = int(CONFIGS.get("api.limits", "DOWNLOADS_PER_MINUTE"))
except NoOptionError:
    DOWNLOADS_PER_MINUTE = None
try:
    DOWNLOADS_PER_HOUR = int(CONFIGS.get("api.limits", "DOWNLOADS_PER_HOUR"))
except NoOptionError:
    DOWNLOADS_PER_HOUR = None
try:
    DOWNLOADS_PER_DAY = int(CONFIGS.get("api.limits", "DOWNLOADS_PER_DAY"))
except NoOptionError:
    DOWNLOADS_PER_DAY = None
try:
    SOURCES_PER_MINUTE = int(CONFIGS.get("api.limits", "SOURCES_PER_MINUTE"))
except NoOptionError:
    SOURCES_PER_MINUTE = None
try:
    SOURCES_PER_HOUR = int(CONFIGS.get("api.limits", "SOURCES_PER_HOUR"))
except NoOptionError:
    SOURCES_PER_HOUR = None
try:
    SOURCES_PER_DAY = int(CONFIGS.get("api.limits", "SOURCES_PER_DAY"))
except NoOptionError:
    SOURCES_PER_DAY = None

WEEKDAY_START_TIME = datetime.datetime.strptime(CONFIGS.get("api.limits", "WEEKDAY_START_TIME"), '%H:%M').time()
WEEKDAY_END_TIME = datetime.datetime.strptime(CONFIGS.get("api.limits", "WEEKDAY_END_TIME"), '%H:%M').time()
WEEKEND_START_TIME = datetime.datetime.strptime(CONFIGS.get("api.limits", "WEEKEND_START_TIME"), '%H:%M').time()
WEEKEND_END_TIME = datetime.datetime.strptime(CONFIGS.get("api.limits", "WEEKEND_END_TIME"), '%H:%M').time()

# App OAuth Configs
OAUTH_BYPASS = CONFIGS.get("oauth", "BYPASS").lower() == 'true'
OAUTH_BYPASS_USER = CONFIGS.get("oauth", "BYPASS_USER")
APP_AUTH_URL = CONFIGS.get("oauth", "AUTH_URL")
APP_TOKEN_URL = CONFIGS.get("oauth", "TOKEN_URL")
APP_PROFILE_URL = CONFIGS.get("oauth", "PROFILE_URL")
APP_LOGOUT_URL = CONFIGS.get("oauth", "LOGOUT_URL")
APP_CLIENT_ID = CONFIGS.get("oauth", "CLIENT_ID")
APP_CLIENT_SECRET = CONFIGS.get("oauth", "CLIENT_SECRET")
APP_REDIRECT_URL = CONFIGS.get("oauth", "REDIRECT_URL")
APP_USER_ID_FIELD = CONFIGS.get("oauth", "USER_ID_FIELD")


# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = CONFIGS.get("secretkey", "SECRET_KEY")

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = CONFIGS.get("debug", "DEBUG").lower() == 'true'
LOG_DEBUG_LEVEL = CONFIGS.get("debug", "LOG_DEBUG_LEVEL").lower() == 'true'

if LOG_DEBUG_LEVEL:
    # will output to console
    logging.basicConfig(level=logging.DEBUG, format='%(asctime)s %(levelname)-8s %(process)-7d %(message)s', datefmt='%a, %d %b %Y %H:%M:%S', filemode='w')
else:
    logging.basicConfig(level=logging.INFO, format='%(asctime)s %(levelname)-8s %(process)-7d %(message)s', datefmt='%a, %d %b %Y %H:%M:%S', filemode='w')

ALLOWED_HOSTS = [host.strip() for host in CONFIGS.get("hosts", "ALLOWED_HOSTS").split(", ")]

# General settings
MAINTAINER_EMAILS = [email.strip() for email in CONFIGS.get("general", "MAINTAINER_EMAILS").split(", ")]
NOTIF_EMAIL_DOMAIN = CONFIGS.get("general", "NOTIF_EMAIL_DOMAIN")
BCC_MAINTAINERS_ON_NOTIF = CONFIGS.get("general", "BCC_MAINTAINERS_ON_NOTIF").lower() == 'true'
PREFERED_HOST_URL = CONFIGS.get("hosts", "PREFERED_HOST_URL")
EMAIL_MAINTAINERS_ON_API_ERROR = CONFIGS.get("general", "EMAIL_MAINTAINERS_ON_API_ERROR").lower() == 'true'
EMAIL_FROM = CONFIGS.get("general", "EMAIL_FROM")


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.humanize',
    'crispy_forms',
    'textassembler_processor.apps.TextassemblerProcessorConfig',
    'textassembler_web.apps.TextassemblerWebConfig',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'whitenoise.middleware.WhiteNoiseMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',

]

ROOT_URLCONF = 'textassembler.urls'
CRISPY_TEMPLATE_PACK = 'bootstrap4'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]
# Static file serving.
# https://whitenoise.readthedocs.io/en/stable/django.html#add-compression-and-caching-support
STORAGES = {
    # ...
    "staticfiles": {
        "BACKEND": "whitenoise.storage.CompressedManifestStaticFilesStorage",
    },
}

WSGI_APPLICATION = 'textassembler.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.2/ref/settings/#databases
# Database
DATABASES = {'default': dict(CONFIGS.items("database.default")),}
# Check for ATOMIC_REQUESTS setting. If not set, defaults to True.
ATOMIC_REQUESTS = DATABASES['default'].get('ATOMIC_REQUESTS', "True").lower() == "true"
DATABASES['default']['ATOMIC_REQUESTS'] = ATOMIC_REQUESTS
# Check for CONN_MAX_AGE, if not set, set to 0
CONN_MAX_AGE = DATABASES['default'].get('CONN_MAX_AGE', 0)
DATABASES['default']['CONN_MAX_AGE'] = int(CONN_MAX_AGE)

# Activating STRICT_ALL_TABLES mode forces truncated strings inserted into
# the database to produce errors instead of warnings.
DATABASES['default']['OPTIONS'] = {
    'sql_mode': 'STRICT_ALL_TABLES', 
}
# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = CONFIGS.get("general", "TIME_ZONE")
TZ = CONFIGS.get("general", "TIME_ZONE")

#USE_I18N = True

#USE_L10N = True

#USE_TZ = True

# Increase the default POST size due to how we pass the intermediate results
# back and forth between the client and server between requests.
DATA_UPLOAD_MAX_MEMORY_SIZE = 5242880

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static/')
